#!/usr/bin/python
# -*- coding: ISO-8859-1 -*-


#######################################
# EINSTELLUNGEN
#
# der Port, unter dem der Server auf 
# der IP-Adresse der Box erreichbar ist
CONFIG_SERVERPORT=80   
# Das Verzeichniss das im Server frei-
# gegeben ist
CONFIG_WWWROOT="/usr/lib/enigma2/python/Plugins/Extensions/DM7025remote"
#
#######################################
# ab hier nix ndern, auer man wei 
# was man tut ;-)
#######################################
import CGIHTTPServer, SocketServer
import BaseHTTPServer
import os, sys, socket

class MyRequestHandler( CGIHTTPServer.CGIHTTPRequestHandler ):
    """Modifizieren des Standart RequestHandlers"""
    #cgi_directories = ['/cgi-bin', '/htbin']
        
    def is_cgi(self):
        """
        Einfachere Variante, sodas alle Python-Skripte berall ausgefhrt werden#
        """
        base, filename = os.path.split( self.path.split("?")[0] )

        if ".py" in filename:
            if "?" in filename:
                os.environ["SCRIPT_FILENAME"] = filename.split("?",1)[0]                
            else:
                os.environ["SCRIPT_FILENAME"] = filename
            os.environ['DOCUMENT_ROOT']     = os.getcwd()
            self.cgi_info = base, filename
            return True 
        
class MyThreadingServer( SocketServer.ThreadingTCPServer ):
    """
    Verbesserung des Standart Servers:
     - ermglicht das abarbeiten mehrere Anfragen parallel (z.B. Download mehrere Dateien gleichzeitig)
     - Ermglicht das einschrnken des IP-Bereiches aus denen der Server Anfragen behandelt
    """
    allow_reuse_address = 1    # Seems to make sense in testing environment


    def __init__(self, server_address, request_handler, AllowIPs):
        SocketServer.ThreadingTCPServer.__init__(self, server_address, request_handler)
        self.AllowIPs = [mask.split('.') for mask in AllowIPs]

    def server_bind(self):
        """Override server_bind to store the server name. (Parallele Anfragen)"""
        SocketServer.ThreadingTCPServer.server_bind(self)
        host, self.server_port = self.socket.getsockname()[:2]
        self.server_name = socket.getfqdn(host)

    def verify_request(self, dummy, client_address):
        """Checkt ob die IP-Adresse der Anfrage in 'AllowIPs' vorhanden ist"""
        def check_ip(mask):
            for mask_part, ip_part in zip(mask, ip):
                if mask_part != ip_part and mask_part != '*':
                    return False
            return True

        ip = client_address[0].split('.')

        for mask in self.AllowIPs:
            if check_ip(mask):
                return True

        print "IP [%s] not allowed!" % (client_address)

        return False
    
        
    
def ServerStart( ListenPort, AllowIPs ):
    print "="*80
    print "ROOT-Pfad .......................:", os.getcwd()
    print "Starte CGI-HTTP-Server auf Port .:", ListenPort
    print "Zugelassener IP-Bereich .........:", AllowIPs
    print "Seiten sind nun unter [http://localhost:%s] erreichbar!" % ListenPort
    print "="*80
    httpd = MyThreadingServer( ("", ListenPort), MyRequestHandler, AllowIPs )
    httpd.serve_forever()

os.chdir(CONFIG_WWWROOT)

ServerStart(
        ListenPort  = CONFIG_SERVERPORT,
        AllowIPs    = ('127.0.0.1', '*.*.*.*')
    )
